"use strict";
/*!
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const retry_1 = require("retry");
exports.FUZZ_MS = 500;
// 5 tries spanning about 1 minute
exports.LISTEN_RETRY_TIMEOUTS = Object.freeze(retry_1.timeouts({
    minTimeout: 500,
    maxTimeout: Infinity,
    factor: 4.5,
    retries: 4,
    randomize: false
}));
exports.INTERNAL_RETRY_OPTIONS = {
    minTimeout: 100,
    maxTimeout: Infinity,
    factor: 3,
    retries: 4,
    randomize: false
};
exports.DEFAULT_RETRY_OPTIONS = {
    minTimeout: 1000,
    maxTimeout: Infinity,
    factor: 3.5,
    retries: 4,
    randomize: false
};
/**
 * Configuration to disable retries in {@link ListenOptions.retries}.
 *
 * @public
 */
exports.NO_RETRY = {
    minTimeout: 0,
    maxTimeout: 0,
    factor: 0,
    retries: 0,
    randomize: false
};
exports.REFRESH_INTERVAL = 5000;
exports.LOCK_RATIO = 2 / 3;
exports.DEFAULT_DATABASE_THROUGHPUT = 1000;
exports.DEFAULT_PAGE_SIZE = 25;
exports.RU_HEADER = 'x-ms-request-charge';
exports.SESSION_TOKEN_HEADER = 'x-ms-session-token';
exports.CONTINUATION_HEADER = 'x-ms-continuation';
//# sourceMappingURL=constants.js.map