"use strict";
/*!
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const codes_1 = __importDefault(require("./codes"));
const ERROR_MESSAGE = {
    [codes_1.default.DATABASE_ACCOUNT_NOT_FOUND]: 'The database account DNS could not be located (ENOTFOUND).',
    [codes_1.default.DATABASE_RESOURCE_CONCURRENCY_VIOLATION]: 'The resource has changed since it was last requested. Re-fetch it before trying to update it again.',
    [codes_1.default.DATABASE_INTERNAL_ERROR]: 'The database service encountered an internal error processing the request',
    [codes_1.default.DATABASE_INVALID_CREDENTIALS]: 'The provided database credentials are invalid.',
    [codes_1.default.DATABASE_INVALID_REQUEST]: 'The request made to the database is invalid.',
    [codes_1.default.DATABASE_OPERATION_FORBIDDEN]: 'The requested operation cannot be performed due to exceeded quota or expired credentials.',
    [codes_1.default.DATABASE_RESOURCE_ALREADY_EXISTS]: 'Cannot create because a resource with the same id already exists on the database.',
    [codes_1.default.DATABASE_RESOURCE_NOT_FOUND]: 'The requested database resource was not found.',
    [codes_1.default.DATABASE_SPROC_TIMED_OUT]: 'The stored procedure did not finish executing in the allotted time.',
    [codes_1.default.DATABASE_THROUGHPUT_EXCEEDED]: 'The provisioned database throughput has been exceeded.',
    [codes_1.default.DATABASE_TRANSIENT_WRITE_FAILURE]: 'The database encountered a transient failure while writing data. It is safe to retry the operation.',
    [codes_1.default.DATABASE_UNAVAILABLE]: 'The database service is currently unavailable.',
    [codes_1.default.INTERCEPTOR_NEXT_FUNCTION_ALREADY_CALLED]: 'The next function for this interceptor has already been called. Next functions may only be called once.',
    [codes_1.default.INVALID_CRON_STRING_INTERVAL]: 'The provided cron string interval is invalid.',
    [codes_1.default.LISTENER_DESTROYED]: 'Cannot destroy a listener that is already destroyed.',
    [codes_1.default.PROCESSING_ALREADY_FINISHED]: 'Task processing has already finished.',
    [codes_1.default.PROCESSING_FINISH_IN_PROGRESS]: 'Finishing is already in progress. Cannot finish again.',
    [codes_1.default.PROCESSING_LOCK_LOST]: 'Task lock has been lost.',
    [codes_1.default.TASK_ALREADY_SAVING_PAYLOAD]: 'Task payload is already being saved. Multiple concurrent payload saves are not allowed.',
    [codes_1.default.TASK_TOO_LARGE]: 'Cannot save the task because it is too big. Tasks must take less than 2MB of storage space.'
};
exports.default = ERROR_MESSAGE;
//# sourceMappingURL=messages.js.map