/*!
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
import { Listener, TaskClient } from '../client';
import { ActiveTask, ProcessingResult, ReadonlyTask, Task } from '../task';
import Interceptors from './schema';
/**
 * @public
 */
export default class InterceptorProcessor {
    private _interceptors;
    constructor(interceptors: Interceptors);
    client<T>(client: TaskClient, operation: Interceptors.TaskClientOperation, ref: string, type: string | undefined, handler: () => Promise<AnnotatedResponse<T>>): Promise<T>;
    task<T>(task: Task<any> | ActiveTask<any> | ReadonlyTask<any>, operation: Interceptors.TaskOperation, ref: string, handler: () => Promise<AnnotatedResponse<T>>): Promise<T>;
    processing(listener: Listener<any>, task: ActiveTask<any>, ref: string, handler: () => Promise<{
        result: ProcessingResult;
        error?: any;
        delayMs?: number;
    }>): Promise<void>;
}
export interface AnnotatedResponse<T> {
    ruConsumption?: number;
    continuation?: string;
    result: T;
}
//# sourceMappingURL=processor.d.ts.map