"use strict";
/*!
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Interfaces and helper types for the interceptor capability set.
 *
 * @public
 */
var Interceptors;
(function (Interceptors) {
    /**
     * Enumeration of operations that can be triggered via the client interceptor.
     */
    let TaskClientOperation;
    (function (TaskClientOperation) {
        TaskClientOperation["Create"] = "create";
        TaskClientOperation["Get"] = "get";
        TaskClientOperation["List"] = "list";
        TaskClientOperation["ListPaged"] = "listPaged";
        TaskClientOperation["ListSummary"] = "listSummary";
        TaskClientOperation["ListSummaryPaged"] = "listSummaryPaged";
        TaskClientOperation["ListAll"] = "listAll";
        TaskClientOperation["ListAllSummary"] = "listAllSummary";
        TaskClientOperation["Iterate"] = "iterate";
        TaskClientOperation["IterateSummary"] = "iterateSummary";
        TaskClientOperation["IterateAll"] = "iterateAll";
        TaskClientOperation["IterateAllSummary"] = "iterateAllSummary";
        TaskClientOperation["Count"] = "count";
        TaskClientOperation["CountAll"] = "countAll";
        TaskClientOperation["Disable"] = "disable";
        TaskClientOperation["DisableAll"] = "disableAll";
        TaskClientOperation["Enable"] = "enable";
        TaskClientOperation["EnableAll"] = "enableAll";
        TaskClientOperation["Delete"] = "delete";
        TaskClientOperation["DeleteAll"] = "deleteAll";
        TaskClientOperation["DeleteOne"] = "deleteOne";
        TaskClientOperation["LockTasks"] = "lockTasks";
        TaskClientOperation["RegisterSprocs"] = "registerSprocs";
    })(TaskClientOperation = Interceptors.TaskClientOperation || (Interceptors.TaskClientOperation = {}));
    /**
     * Enumeration of operations that can be triggered via the task interceptor.
     */
    let TaskOperation;
    (function (TaskOperation) {
        TaskOperation["Refresh"] = "refresh";
        TaskOperation["Enable"] = "enable";
        TaskOperation["Disable"] = "disable";
        TaskOperation["Save"] = "save";
        TaskOperation["RenewLock"] = "renewLock";
        TaskOperation["Complete"] = "complete";
        TaskOperation["Retry"] = "retry";
        TaskOperation["Fail"] = "fail";
        TaskOperation["Defer"] = "defer";
        TaskOperation["Release"] = "release";
        TaskOperation["Delete"] = "delete";
    })(TaskOperation = Interceptors.TaskOperation || (Interceptors.TaskOperation = {}));
})(Interceptors || (Interceptors = {}));
exports.default = Interceptors;
//# sourceMappingURL=schema.js.map