/*!
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
import { SqlQuerySpec } from '@azure/cosmos';
import Type from '../types';
/**
 * Build a Cosmos DB SQL query from the following options. Defaults to selecting
 * all data from every document in the collection with no sort.
 *
 * @param config Object representation of the query to build
 */
export default function build(config: {
    offset?: number;
    limit?: number;
    rawProjection?: string;
    projection?: Type.AnyProperty[];
    filter?: Type.Bool;
    sort?: Type.Num;
    sortOrder?: 'ASC' | 'DESC';
}): Required<SqlQuerySpec>;
//# sourceMappingURL=query.d.ts.map