/*!
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * @public
 */
declare namespace FnSymbol {
    /**
     * @public
     */
    const ABS: unique symbol;
    /**
     * @public
     */
    const ACOS: unique symbol;
    /**
     * @public
     */
    const ASIN: unique symbol;
    /**
     * @public
     */
    const ATAN: unique symbol;
    /**
     * @public
     */
    const ATN2: unique symbol;
    /**
     * @public
     */
    const CEILING: unique symbol;
    /**
     * @public
     */
    const COS: unique symbol;
    /**
     * @public
     */
    const COT: unique symbol;
    /**
     * @public
     */
    const DEGREES: unique symbol;
    /**
     * @public
     */
    const EXP: unique symbol;
    /**
     * @public
     */
    const FLOOR: unique symbol;
    /**
     * @public
     */
    const LOG: unique symbol;
    /**
     * @public
     */
    const LOG10: unique symbol;
    /**
     * @public
     */
    const PI: unique symbol;
    /**
     * @public
     */
    const POWER: unique symbol;
    /**
     * @public
     */
    const RADIANS: unique symbol;
    /**
     * @public
     */
    const ROUND: unique symbol;
    /**
     * @public
     */
    const SIN: unique symbol;
    /**
     * @public
     */
    const SQRT: unique symbol;
    /**
     * @public
     */
    const SQUARE: unique symbol;
    /**
     * @public
     */
    const SIGN: unique symbol;
    /**
     * @public
     */
    const TAN: unique symbol;
    /**
     * @public
     */
    const TRUNC: unique symbol;
    /**
     * @public
     */
    const IS_ARRAY: unique symbol;
    /**
     * @public
     */
    const IS_BOOL: unique symbol;
    /**
     * @public
     */
    const IS_DEFINED: unique symbol;
    /**
     * @public
     */
    const IS_NULL: unique symbol;
    /**
     * @public
     */
    const IS_NUMBER: unique symbol;
    /**
     * @public
     */
    const IS_OBJECT: unique symbol;
    /**
     * @public
     */
    const IS_PRIMITIVE: unique symbol;
    /**
     * @public
     */
    const IS_STRING: unique symbol;
    /**
     * @public
     */
    /**
     * @public
     */
    const CONTAINS: unique symbol;
    /**
     * @public
     */
    const ENDSWITH: unique symbol;
    /**
     * @public
     */
    const INDEX_OF: unique symbol;
    /**
     * @public
     */
    const LEFT: unique symbol;
    /**
     * @public
     */
    const LENGTH: unique symbol;
    /**
     * @public
     */
    const LOWER: unique symbol;
    /**
     * @public
     */
    const LTRIM: unique symbol;
    /**
     * @public
     */
    const REPLACE: unique symbol;
    /**
     * @public
     */
    const REPLICATE: unique symbol;
    /**
     * @public
     */
    const REVERSE: unique symbol;
    /**
     * @public
     */
    const RIGHT: unique symbol;
    /**
     * @public
     */
    const RTRIM: unique symbol;
    /**
     * @public
     */
    const STARTSWITH: unique symbol;
    /**
     * @public
     */
    const SUBSTRING: unique symbol;
    /**
     * @public
     */
    const TO_STRING: unique symbol;
    /**
     * @public
     */
    const TRIM: unique symbol;
    /**
     * @public
     */
    const UPPER: unique symbol;
    /**
     * @public
     */
    const ARRAY_CONCAT: unique symbol;
    /**
     * @public
     */
    const ARRAY_CONTAINS: unique symbol;
    /**
     * @public
     */
    const ARRAY_LENGTH: unique symbol;
    /**
     * @public
     */
    const ARRAY_SLICE: unique symbol;
    /**
     * @public
     */
    const ST_DISTANCE: unique symbol;
    /**
     * @public
     */
    const ST_WITHIN: unique symbol;
    /**
     * @public
     */
    const ST_INTERSECTS: unique symbol;
    /**
     * @public
     */
    const ST_ISVALID: unique symbol;
    /**
     * @public
     */
    const ST_ISVALIDDETAILED: unique symbol;
    /**
     * @internal
     */
    function getName(sym: FnSymbol): string;
}
/**
 * @public
 */
declare type FnSymbol = typeof FnSymbol.ABS | typeof FnSymbol.ACOS | typeof FnSymbol.ASIN | typeof FnSymbol.ATAN | typeof FnSymbol.ATN2 | typeof FnSymbol.CEILING | typeof FnSymbol.COS | typeof FnSymbol.COT | typeof FnSymbol.DEGREES | typeof FnSymbol.EXP | typeof FnSymbol.FLOOR | typeof FnSymbol.LOG | typeof FnSymbol.LOG10 | typeof FnSymbol.PI | typeof FnSymbol.POWER | typeof FnSymbol.RADIANS | typeof FnSymbol.ROUND | typeof FnSymbol.SIN | typeof FnSymbol.SQRT | typeof FnSymbol.SQUARE | typeof FnSymbol.SIGN | typeof FnSymbol.TAN | typeof FnSymbol.TRUNC | typeof FnSymbol.IS_ARRAY | typeof FnSymbol.IS_BOOL | typeof FnSymbol.IS_DEFINED | typeof FnSymbol.IS_NULL | typeof FnSymbol.IS_NUMBER | typeof FnSymbol.IS_OBJECT | typeof FnSymbol.IS_PRIMITIVE | typeof FnSymbol.IS_STRING | typeof FnSymbol.CONTAINS | typeof FnSymbol.ENDSWITH | typeof FnSymbol.INDEX_OF | typeof FnSymbol.LEFT | typeof FnSymbol.LENGTH | typeof FnSymbol.LOWER | typeof FnSymbol.LTRIM | typeof FnSymbol.REPLACE | typeof FnSymbol.REPLICATE | typeof FnSymbol.REVERSE | typeof FnSymbol.RIGHT | typeof FnSymbol.RTRIM | typeof FnSymbol.STARTSWITH | typeof FnSymbol.SUBSTRING | typeof FnSymbol.TO_STRING | typeof FnSymbol.TRIM | typeof FnSymbol.UPPER | typeof FnSymbol.ARRAY_CONCAT | typeof FnSymbol.ARRAY_CONTAINS | typeof FnSymbol.ARRAY_LENGTH | typeof FnSymbol.ARRAY_SLICE | typeof FnSymbol.ST_DISTANCE | typeof FnSymbol.ST_WITHIN | typeof FnSymbol.ST_INTERSECTS | typeof FnSymbol.ST_ISVALID | typeof FnSymbol.ST_ISVALIDDETAILED;
export default FnSymbol;
//# sourceMappingURL=functions.d.ts.map