"use strict";
/*!
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
// Mathematical functions
/**
 * @public
 */
// tslint:disable:naming-convention
var FnSymbol;
(function (FnSymbol) {
    /**
     * @public
     */
    FnSymbol.ABS = Symbol('ABS');
    /**
     * @public
     */
    FnSymbol.ACOS = Symbol('ACOS');
    /**
     * @public
     */
    FnSymbol.ASIN = Symbol('ASIN');
    /**
     * @public
     */
    FnSymbol.ATAN = Symbol('ATAN');
    /**
     * @public
     */
    FnSymbol.ATN2 = Symbol('ATN2');
    /**
     * @public
     */
    FnSymbol.CEILING = Symbol('CEILING');
    /**
     * @public
     */
    FnSymbol.COS = Symbol('COS');
    /**
     * @public
     */
    FnSymbol.COT = Symbol('COT');
    /**
     * @public
     */
    FnSymbol.DEGREES = Symbol('DEGREES');
    /**
     * @public
     */
    FnSymbol.EXP = Symbol('EXP');
    /**
     * @public
     */
    FnSymbol.FLOOR = Symbol('FLOOR');
    /**
     * @public
     */
    FnSymbol.LOG = Symbol('LOG');
    /**
     * @public
     */
    FnSymbol.LOG10 = Symbol('LOG10');
    /**
     * @public
     */
    FnSymbol.PI = Symbol('PI');
    /**
     * @public
     */
    FnSymbol.POWER = Symbol('POWER');
    /**
     * @public
     */
    FnSymbol.RADIANS = Symbol('RADIANS');
    /**
     * @public
     */
    FnSymbol.ROUND = Symbol('ROUND');
    /**
     * @public
     */
    FnSymbol.SIN = Symbol('SIN');
    /**
     * @public
     */
    FnSymbol.SQRT = Symbol('SQRT');
    /**
     * @public
     */
    FnSymbol.SQUARE = Symbol('SQUARE');
    /**
     * @public
     */
    FnSymbol.SIGN = Symbol('SIGN');
    /**
     * @public
     */
    FnSymbol.TAN = Symbol('TAN');
    /**
     * @public
     */
    FnSymbol.TRUNC = Symbol('TRUNC');
    // Type-checking functions
    /**
     * @public
     */
    FnSymbol.IS_ARRAY = Symbol('IS_ARRAY');
    /**
     * @public
     */
    FnSymbol.IS_BOOL = Symbol('IS_BOOL');
    /**
     * @public
     */
    FnSymbol.IS_DEFINED = Symbol('IS_DEFINED');
    /**
     * @public
     */
    FnSymbol.IS_NULL = Symbol('IS_NULL');
    /**
     * @public
     */
    FnSymbol.IS_NUMBER = Symbol('IS_NUMBER');
    /**
     * @public
     */
    FnSymbol.IS_OBJECT = Symbol('IS_OBJECT');
    /**
     * @public
     */
    FnSymbol.IS_PRIMITIVE = Symbol('IS_PRIMITIVE');
    /**
     * @public
     */
    FnSymbol.IS_STRING = Symbol('IS_STRING');
    /**
     * @public
     */
    // String functions
    /**
     * @public
     */
    FnSymbol.CONTAINS = Symbol('CONTAINS');
    /**
     * @public
     */
    FnSymbol.ENDSWITH = Symbol('ENDSWITH');
    /**
     * @public
     */
    FnSymbol.INDEX_OF = Symbol('INDEX_OF');
    /**
     * @public
     */
    FnSymbol.LEFT = Symbol('LEFT');
    /**
     * @public
     */
    FnSymbol.LENGTH = Symbol('LENGTH');
    /**
     * @public
     */
    FnSymbol.LOWER = Symbol('LOWER');
    /**
     * @public
     */
    FnSymbol.LTRIM = Symbol('LTRIM');
    /**
     * @public
     */
    FnSymbol.REPLACE = Symbol('REPLACE');
    /**
     * @public
     */
    FnSymbol.REPLICATE = Symbol('REPLICATE');
    /**
     * @public
     */
    FnSymbol.REVERSE = Symbol('REVERSE');
    /**
     * @public
     */
    FnSymbol.RIGHT = Symbol('RIGHT');
    /**
     * @public
     */
    FnSymbol.RTRIM = Symbol('RTRIM');
    /**
     * @public
     */
    FnSymbol.STARTSWITH = Symbol('STARTSWITH');
    /**
     * @public
     */
    FnSymbol.SUBSTRING = Symbol('SUBSTRING');
    /**
     * @public
     */
    FnSymbol.TO_STRING = Symbol('ToString');
    /**
     * @public
     */
    FnSymbol.TRIM = Symbol('TRIM');
    /**
     * @public
     */
    FnSymbol.UPPER = Symbol('UPPER');
    // Array functions
    /**
     * @public
     */
    FnSymbol.ARRAY_CONCAT = Symbol('ARRAY_CONCAT');
    /**
     * @public
     */
    FnSymbol.ARRAY_CONTAINS = Symbol('ARRAY_CONTAINS');
    /**
     * @public
     */
    FnSymbol.ARRAY_LENGTH = Symbol('ARRAY_LENGTH');
    /**
     * @public
     */
    FnSymbol.ARRAY_SLICE = Symbol('ARRAY_SLICE');
    // Spatial functions
    /**
     * @public
     */
    FnSymbol.ST_DISTANCE = Symbol('ST_DISTANCE');
    /**
     * @public
     */
    FnSymbol.ST_WITHIN = Symbol('ST_WITHIN');
    /**
     * @public
     */
    FnSymbol.ST_INTERSECTS = Symbol('ST_INTERSECTS');
    /**
     * @public
     */
    FnSymbol.ST_ISVALID = Symbol('ST_ISVALID');
    /**
     * @public
     */
    FnSymbol.ST_ISVALIDDETAILED = Symbol('ST_ISVALIDDETAILED');
    /**
     * @internal
     */
    function getName(sym) {
        switch (sym) {
            case FnSymbol.ABS:
                return 'ABS';
            case FnSymbol.ACOS:
                return 'ACOS';
            case FnSymbol.ASIN:
                return 'ASIN';
            case FnSymbol.ATAN:
                return 'ATAN';
            case FnSymbol.ATN2:
                return 'ATN2';
            case FnSymbol.CEILING:
                return 'CEILING';
            case FnSymbol.COS:
                return 'COS';
            case FnSymbol.COT:
                return 'COT';
            case FnSymbol.DEGREES:
                return 'DEGREES';
            case FnSymbol.EXP:
                return 'EXP';
            case FnSymbol.FLOOR:
                return 'FLOOR';
            case FnSymbol.LOG:
                return 'LOG';
            case FnSymbol.LOG10:
                return 'LOG10';
            case FnSymbol.PI:
                return 'PI';
            case FnSymbol.POWER:
                return 'POWER';
            case FnSymbol.RADIANS:
                return 'RADIANS';
            case FnSymbol.ROUND:
                return 'ROUND';
            case FnSymbol.SIN:
                return 'SIN';
            case FnSymbol.SQRT:
                return 'SQRT';
            case FnSymbol.SQUARE:
                return 'SQUARE';
            case FnSymbol.SIGN:
                return 'SIGN';
            case FnSymbol.TAN:
                return 'TAN';
            case FnSymbol.TRUNC:
                return 'TRUNC';
            // Type-checking functions
            case FnSymbol.IS_ARRAY:
                return 'IS_ARRAY';
            case FnSymbol.IS_BOOL:
                return 'IS_BOOL';
            case FnSymbol.IS_DEFINED:
                return 'IS_DEFINED';
            case FnSymbol.IS_NULL:
                return 'IS_NULL';
            case FnSymbol.IS_NUMBER:
                return 'IS_NUMBER';
            case FnSymbol.IS_OBJECT:
                return 'IS_OBJECT';
            case FnSymbol.IS_PRIMITIVE:
                return 'IS_PRIMITIVE';
            case FnSymbol.IS_STRING:
                return 'IS_STRING';
            // String functions
            case FnSymbol.CONTAINS:
                return 'CONTAINS';
            case FnSymbol.ENDSWITH:
                return 'ENDSWITH';
            case FnSymbol.INDEX_OF:
                return 'INDEX_OF';
            case FnSymbol.LEFT:
                return 'LEFT';
            case FnSymbol.LENGTH:
                return 'LENGTH';
            case FnSymbol.LOWER:
                return 'LOWER';
            case FnSymbol.LTRIM:
                return 'LTRIM';
            case FnSymbol.REPLACE:
                return 'REPLACE';
            case FnSymbol.REPLICATE:
                return 'REPLICATE';
            case FnSymbol.REVERSE:
                return 'REVERSE';
            case FnSymbol.RIGHT:
                return 'RIGHT';
            case FnSymbol.RTRIM:
                return 'RTRIM';
            case FnSymbol.STARTSWITH:
                return 'STARTSWITH';
            case FnSymbol.SUBSTRING:
                return 'SUBSTRING';
            case FnSymbol.TO_STRING:
                return 'ToString';
            case FnSymbol.TRIM:
                return 'TRIM';
            case FnSymbol.UPPER:
                return 'UPPER';
            // Array functions
            case FnSymbol.ARRAY_CONCAT:
                return 'ARRAY_CONCAT';
            case FnSymbol.ARRAY_CONTAINS:
                return 'ARRAY_CONTAINS';
            case FnSymbol.ARRAY_LENGTH:
                return 'ARRAY_LENGTH';
            case FnSymbol.ARRAY_SLICE:
                return 'ARRAY_SLICE';
            // Spatial functions
            case FnSymbol.ST_DISTANCE:
                return 'ST_DISTANCE';
            case FnSymbol.ST_WITHIN:
                return 'ST_WITHIN';
            case FnSymbol.ST_INTERSECTS:
                return 'ST_INTERSECTS';
            case FnSymbol.ST_ISVALID:
                return 'ST_ISVALID';
            case FnSymbol.ST_ISVALIDDETAILED:
                return 'ST_ISVALIDDETAILED';
        }
    }
    FnSymbol.getName = getName;
})(FnSymbol || (FnSymbol = {}));
exports.default = FnSymbol;
//# sourceMappingURL=functions.js.map