/*!
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * @public
 */
declare namespace OpSymbol {
    /**
     * @public
     */
    const AND: unique symbol;
    /**
     * @public
     */
    const OR: unique symbol;
    /**
     * @public
     */
    const NOT: unique symbol;
    /**
     * @public
     */
    const ADD: unique symbol;
    /**
     * @public
     */
    const SUBTRACT: unique symbol;
    /**
     * @public
     */
    const MULTIPLY: unique symbol;
    /**
     * @public
     */
    const DIVIDE: unique symbol;
    /**
     * @public
     */
    const MODULO: unique symbol;
    /**
     * @public
     */
    const BITWISE_OR: unique symbol;
    /**
     * @public
     */
    const BITWISE_AND: unique symbol;
    /**
     * @public
     */
    const XOR: unique symbol;
    /**
     * @public
     */
    const LEFT_SHIFT: unique symbol;
    /**
     * @public
     */
    const RIGHT_SHIFT: unique symbol;
    /**
     * @public
     */
    const ZF_RIGHT_SHIFT: unique symbol;
    /**
     * @public
     */
    const EQUAL: unique symbol;
    /**
     * @public
     */
    const NOT_EQUAL: unique symbol;
    /**
     * @public
     */
    const GREATER_THAN: unique symbol;
    /**
     * @public
     */
    const GREATER_THAN_OR_EQUAL: unique symbol;
    /**
     * @public
     */
    const LESS_THAN: unique symbol;
    /**
     * @public
     */
    const LESS_THAN_OR_EQUAL: unique symbol;
    /**
     * @public
     */
    const COALESCE: unique symbol;
    /**
     * @public
     */
    const CONCATENATE: unique symbol;
    /**
     * @public
     */
    const TERNARY: unique symbol;
    /**
     * @public
     */
    const IN: unique symbol;
    /**
     * @internal
     */
    function getOp(sym: Exclude<OpSymbol, typeof OpSymbol.TERNARY>): string;
}
/**
 * @public
 */
declare type OpSymbol = typeof OpSymbol.AND | typeof OpSymbol.OR | typeof OpSymbol.NOT | typeof OpSymbol.ADD | typeof OpSymbol.SUBTRACT | typeof OpSymbol.MULTIPLY | typeof OpSymbol.DIVIDE | typeof OpSymbol.MODULO | typeof OpSymbol.BITWISE_OR | typeof OpSymbol.BITWISE_AND | typeof OpSymbol.XOR | typeof OpSymbol.LEFT_SHIFT | typeof OpSymbol.RIGHT_SHIFT | typeof OpSymbol.ZF_RIGHT_SHIFT | typeof OpSymbol.EQUAL | typeof OpSymbol.NOT_EQUAL | typeof OpSymbol.GREATER_THAN | typeof OpSymbol.GREATER_THAN_OR_EQUAL | typeof OpSymbol.LESS_THAN | typeof OpSymbol.LESS_THAN_OR_EQUAL | typeof OpSymbol.COALESCE | typeof OpSymbol.CONCATENATE | typeof OpSymbol.TERNARY | typeof OpSymbol.IN;
export default OpSymbol;
//# sourceMappingURL=operators.d.ts.map