/*!
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
import { QueryType } from '../query';
/**
 * Computes the overall projection for a task summary, given the projections for
 * the payload within the task.
 *
 * @param projections Property projections to include from the payload
 */
export declare function summaryProjection(projections?: QueryType.AnyProperty[]): QueryType.AnyProperty[];
/**
 * Produces a filter for tasks of the given type, with optional additional
 * filters applied.
 *
 * @param type The task's type
 * @param filter Optional additional filter to apply to the task
 */
export declare function typeFilter(type: string, filter?: QueryType.Bool): QueryType.BinaryLogical | QueryType.Equality;
//# sourceMappingURL=query.d.ts.map