/*!
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
import { TaskDocument } from './document';
import { TaskStatus } from './types';
/**
 * Computes the current status of a task from the task document information.
 *
 * @param config    The configuration portion of the task document
 * @param now       The current unix ms time to use for computing task state
 */
export default function taskStatus(config: TaskDocument<any>['config'], now: number): TaskStatus;
/**
 * Returns true if the task is in a terminal state.
 *
 * @param config    The configuration portion of the task document
 * @param now       The current unix ms time to use for computing task state
 */
export declare function isFinished(config: TaskDocument<any>['config'], now: number): boolean;
//# sourceMappingURL=status.d.ts.map