/*!
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Groups entries from a single result iterator into batches of the specified
 * size, yielding them in groups instead of individually.
 *
 * @param iterator Source iterator that returns resuls one at a time
 * @param batchSize Maximum number of results to include in a single batch
 */
export default function batchIterator<T>(iterator: AsyncIterable<T>, batchSize: number): AsyncIterable<T[]>;
//# sourceMappingURL=batchIterator.d.ts.map