/*!
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Computes the unix ms epoch when the task should be run next from the interval,
 * if one is provided. If no time is returned, the task should not be run again.
 *
 * @param interval      Number of milliseconds between runs or cron string.
 * @param previousStart If there was a previous run, the time when that run
 *                      started
 * @param lastRunTime   The last valid time nextRunTime can be set to.
 */
export default function computeNextRun(interval?: string | number, previousStart?: number, lastRunTime?: Date): number | undefined;
//# sourceMappingURL=computeNextRun.d.ts.map